---
machine_translated: true
machine_translated_rev: ad252bbb4f7e2899c448eb42ecc39ff195c8faa1
toc_priority: 40
toc_title: "\u0633\u0627\u0632\u06AF\u0627\u0631\u06CC \u0627\u0646\u0633\u06CC"
---

# سازگاری انسی گذاشتن گویش فاحشه خانه {#ansi-sql-compatibility-of-clickhouse-sql-dialect}

!!! note "یادداشت"
    این مقاله متکی بر جدول 38, “Feature taxonomy and definition for mandatory features”, Annex F of ISO/IEC CD 9075-2:2013.

## تفاوت در رفتار {#differences-in-behaviour}

جدول زیر لیست موارد زمانی که از ویژگی های پرس و جو کار می کند در خانه رعیتی, اما رفتار نه به عنوان مشخص شده در انسی گذاشتن.

| Feature ID | نام ویژگی                             | تفاوت                                                                                      |
|------------|---------------------------------------|--------------------------------------------------------------------------------------------|
| E011       | انواع داده های عددی                   | تحت اللفظی عددی با دوره به عنوان تقریبی تفسیر شده است (`Float64`) به جای دقیق (`Decimal`)  |
| E051-05    | انتخاب موارد را می توان تغییر نام داد | تغییر نام مورد یک دامنه دید گسترده تر از فقط نتیجه را انتخاب کنید                          |
| E141-01    | محدودیت NOT NULL                      | `NOT NULL` برای ستون های جدول به طور پیش فرض ضمنی                                          |
| E011-04    | اپراتورهای ریاضی                      | سرریز کلیک به جای حساب بررسی می شود و نوع داده نتیجه را بر اساس قوانین سفارشی تغییر می دهد |

## وضعیت ویژگی {#feature-status}

| Feature ID | نام ویژگی                                                                                         | وضعیت                   | توضیح                                                                                                                                                                                      |
|------------|---------------------------------------------------------------------------------------------------|-------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **E011**   | **انواع داده های عددی**                                                                           | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| E011-01    | عدد صحیح و SMALLINT انواع داده ها                                                                 | بله{.text-success}      |                                                                                                                                                                                            |
| E011-02    | انواع داده های دقیق و دوگانه واقعی و شناور                                                        | نسبی{.text-warning}     | `FLOAT(<binary_precision>)`, `REAL` و `DOUBLE PRECISION` پشتیبانی نمیشود                                                                                                                   |
| E011-03    | دهدهی و انواع داده های عددی                                                                       | نسبی{.text-warning}     | فقط `DECIMAL(p,s)` پشتیبانی می شود, نه `NUMERIC`                                                                                                                                           |
| E011-04    | اپراتورهای ریاضی                                                                                  | بله{.text-success}      |                                                                                                                                                                                            |
| E011-05    | مقایسه عددی                                                                                       | بله{.text-success}      |                                                                                                                                                                                            |
| E011-06    | ریخته گری ضمنی در میان انواع داده های عددی                                                        | نه{.text-danger}        | انسی گذاشتن اجازه می دهد تا بازیگران ضمنی دلخواه بین انواع عددی, در حالی که تاتر متکی بر توابع داشتن اضافه بار متعدد به جای بازیگران ضمنی                                                  |
| **E021**   | **انواع رشته شخصیت**                                                                              | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| E021-01    | نوع دادههای نویسه                                                                                 | نه{.text-danger}        |                                                                                                                                                                                            |
| E021-02    | شخصیت های مختلف نوع داده ها                                                                       | نه{.text-danger}        | `String` رفتار مشابه, اما بدون محدودیت طول در پرانتز                                                                                                                                       |
| E021-03    | شخصیت literals                                                                                    | نسبی{.text-warning}     | بدون الحاق خودکار از لیتر متوالی و شخصیت پشتیبانی مجموعه                                                                                                                                   |
| E021-04    | تابع \_شخصی                                                                                       | نسبی{.text-warning}     | نه `USING` بند                                                                                                                                                                             |
| E021-05    | تابع اکتبر                                                                                        | نه{.text-danger}        | `LENGTH` رفتار مشابه                                                                                                                                                                       |
| E021-06    | SUBSTRING                                                                                         | نسبی{.text-warning}     | هیچ پشتیبانی برای `SIMILAR` و `ESCAPE` بند نه `SUBSTRING_REGEX` گزینه                                                                                                                      |
| E021-07    | الحاق شخصیت                                                                                       | نسبی{.text-warning}     | نه `COLLATE` بند                                                                                                                                                                           |
| E021-08    | توابع بالا و پایین                                                                                | بله{.text-success}      |                                                                                                                                                                                            |
| E021-09    | تابع اصلاح                                                                                        | بله{.text-success}      |                                                                                                                                                                                            |
| E021-10    | ریخته گری ضمنی در میان ثابت طول و متغیر طول انواع رشته شخصیت                                      | نه{.text-danger}        | انسی گذاشتن اجازه می دهد تا بازیگران ضمنی دلخواه بین انواع رشته, در حالی که تاتر متکی بر توابع داشتن اضافه بار متعدد به جای بازیگران ضمنی                                                  |
| E021-11    | تابع موقعیت                                                                                       | نسبی{.text-warning}     | هیچ پشتیبانی برای `IN` و `USING` بند نه `POSITION_REGEX` گزینه                                                                                                                             |
| E021-12    | مقایسه شخصیت                                                                                      | بله{.text-success}      |                                                                                                                                                                                            |
| **E031**   | **شناسهها**                                                                                       | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| E031-01    | شناسه های محدود                                                                                   | نسبی{.text-warning}     | پشتیبانی تحت اللفظی یونیکد محدود است                                                                                                                                                       |
| E031-02    | شناسه های مورد پایین                                                                              | بله{.text-success}      |                                                                                                                                                                                            |
| E031-03    | انتهایی تاکید                                                                                     | بله{.text-success}      |                                                                                                                                                                                            |
| **E051**   | **مشخصات پرس و جو عمومی**                                                                         | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| E051-01    | SELECT DISTINCT                                                                                   | بله{.text-success}      |                                                                                                                                                                                            |
| E051-02    | گروه بر اساس بند                                                                                  | بله{.text-success}      |                                                                                                                                                                                            |
| E051-04    | گروه توسط می تواند ستون ها را شامل نمی شود `<select list>`                                        | بله{.text-success}      |                                                                                                                                                                                            |
| E051-05    | انتخاب موارد را می توان تغییر نام داد                                                             | بله{.text-success}      |                                                                                                                                                                                            |
| E051-06    | داشتن بند                                                                                         | بله{.text-success}      |                                                                                                                                                                                            |
| E051-07    | واجد شرایط \* در انتخاب لیست                                                                      | بله{.text-success}      |                                                                                                                                                                                            |
| E051-08    | نام همبستگی در بند                                                                                | بله{.text-success}      |                                                                                                                                                                                            |
| E051-09    | تغییر نام ستون ها در بند                                                                          | نه{.text-danger}        |                                                                                                                                                                                            |
| **E061**   | **مخمصه عمومی و شرایط جستجو**                                                                     | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| E061-01    | پیش فرض مقایسه                                                                                    | بله{.text-success}      |                                                                                                                                                                                            |
| E061-02    | بین پیش فرض                                                                                       | نسبی{.text-warning}     | نه `SYMMETRIC` و `ASYMMETRIC` بند                                                                                                                                                          |
| E061-03    | در گزاره با لیستی از ارزش ها                                                                      | بله{.text-success}      |                                                                                                                                                                                            |
| E061-04    | مثل گزاره                                                                                         | بله{.text-success}      |                                                                                                                                                                                            |
| E061-05    | مانند گزاره: فرار بند                                                                             | نه{.text-danger}        |                                                                                                                                                                                            |
| E061-06    | پیش فرض پوچ                                                                                       | بله{.text-success}      |                                                                                                                                                                                            |
| E061-07    | گزاره مقایسه کمی                                                                                  | نه{.text-danger}        |                                                                                                                                                                                            |
| E061-08    | پیش فرض وجود دارد                                                                                 | نه{.text-danger}        |                                                                                                                                                                                            |
| E061-09    | Subqueries در مقایسه گزاره                                                                        | بله{.text-success}      |                                                                                                                                                                                            |
| E061-11    | در حال بارگذاری                                                                                   | بله{.text-success}      |                                                                                                                                                                                            |
| E061-12    | زیرمجموعه ها در پیش بینی مقایسه اندازه گیری شده                                                   | نه{.text-danger}        |                                                                                                                                                                                            |
| E061-13    | ارتباط subqueries                                                                                 | نه{.text-danger}        |                                                                                                                                                                                            |
| E061-14    | وضعیت جستجو                                                                                       | بله{.text-success}      |                                                                                                                                                                                            |
| **E071**   | **عبارتهای پرسوجو پایه**                                                                          | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| E071-01    | اتحادیه اپراتور جدول مجزا                                                                         | نه{.text-danger}        |                                                                                                                                                                                            |
| E071-02    | اتحادیه تمام اپراتور جدول                                                                         | بله{.text-success}      |                                                                                                                                                                                            |
| E071-03    | به جز اپراتور جدول مجزا                                                                           | نه{.text-danger}        |                                                                                                                                                                                            |
| E071-05    | ستون ترکیب از طریق اپراتورهای جدول نیاز دقیقا همان نوع داده ندارد                                 | بله{.text-success}      |                                                                                                                                                                                            |
| E071-06    | اپراتورهای جدول در زیرمجموعه                                                                      | بله{.text-success}      |                                                                                                                                                                                            |
| **E081**   | **امتیازات پایه**                                                                                 | **نسبی**{.text-warning} | کار در حال پیشرفت                                                                                                                                                                          |
| **E091**   | **تنظیم توابع**                                                                                   | **بله**{.text-success}  |                                                                                                                                                                                            |
| E091-01    | AVG                                                                                               | بله{.text-success}      |                                                                                                                                                                                            |
| E091-02    | COUNT                                                                                             | بله{.text-success}      |                                                                                                                                                                                            |
| E091-03    | MAX                                                                                               | بله{.text-success}      |                                                                                                                                                                                            |
| E091-04    | MIN                                                                                               | بله{.text-success}      |                                                                                                                                                                                            |
| E091-05    | SUM                                                                                               | بله{.text-success}      |                                                                                                                                                                                            |
| E091-06    | همه کمی                                                                                           | نه{.text-danger}        |                                                                                                                                                                                            |
| E091-07    | کمی متمایز                                                                                        | نسبی{.text-warning}     | همه توابع مجموع پشتیبانی                                                                                                                                                                   |
| **E101**   | **دستکاری داده های پایه**                                                                         | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| E101-01    | درج بیانیه                                                                                        | بله{.text-success}      | توجه داشته باشید: کلید اصلی در خانه کلیک می کند به این معنی نیست `UNIQUE` محدودیت                                                                                                          |
| E101-03    | بیانیه به روز رسانی جستجو                                                                         | نه{.text-danger}        | یک `ALTER UPDATE` بیانیه ای برای اصلاح داده های دسته ای                                                                                                                                    |
| E101-04    | جستجو حذف بیانیه                                                                                  | نه{.text-danger}        | یک `ALTER DELETE` بیانیه ای برای حذف داده های دسته ای                                                                                                                                      |
| **E111**   | **تک ردیف انتخاب بیانیه**                                                                         | **نه**{.text-danger}    |                                                                                                                                                                                            |
| **E121**   | **پشتیبانی عمومی مکان نما**                                                                       | **نه**{.text-danger}    |                                                                                                                                                                                            |
| E121-01    | DECLARE CURSOR                                                                                    | نه{.text-danger}        |                                                                                                                                                                                            |
| E121-02    | سفارش ستون ها در لیست انتخاب نمی شود                                                              | نه{.text-danger}        |                                                                                                                                                                                            |
| E121-03    | عبارات ارزش به ترتیب توسط بند                                                                     | نه{.text-danger}        |                                                                                                                                                                                            |
| E121-04    | بیانیه باز                                                                                        | نه{.text-danger}        |                                                                                                                                                                                            |
| E121-06    | بیانیه به روز رسانی موقعیت                                                                        | نه{.text-danger}        |                                                                                                                                                                                            |
| E121-07    | موقعیت حذف بیانیه                                                                                 | نه{.text-danger}        |                                                                                                                                                                                            |
| E121-08    | بستن بیانیه                                                                                       | نه{.text-danger}        |                                                                                                                                                                                            |
| E121-10    | واکشی بیانیه: ضمنی بعدی                                                                           | نه{.text-danger}        |                                                                                                                                                                                            |
| E121-17    | با نشانگر نگه دارید                                                                               | نه{.text-danger}        |                                                                                                                                                                                            |
| **E131**   | **پشتیبانی ارزش صفر (صفر به جای ارزش)**                                                           | **نسبی**{.text-warning} | برخی از محدودیت ها اعمال می شود                                                                                                                                                            |
| **E141**   | **محدودیت یکپارچگی عمومی**                                                                        | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| E141-01    | محدودیت NOT NULL                                                                                  | بله{.text-success}      | یادداشت: `NOT NULL` برای ستون های جدول به طور پیش فرض ضمنی                                                                                                                                 |
| E141-02    | محدودیت منحصر به فرد از ستون تهی نیست                                                             | نه{.text-danger}        |                                                                                                                                                                                            |
| E141-03    | محدودیت های کلیدی اولیه                                                                           | نه{.text-danger}        |                                                                                                                                                                                            |
| E141-04    | محدودیت کلید خارجی عمومی با هیچ پیش فرض اقدام برای هر دو عمل حذف ارجاعی و عمل به روز رسانی ارجاعی | نه{.text-danger}        |                                                                                                                                                                                            |
| E141-06    | بررسی محدودیت                                                                                     | بله{.text-success}      |                                                                                                                                                                                            |
| E141-07    | پیشفرض ستون                                                                                       | بله{.text-success}      |                                                                                                                                                                                            |
| E141-08    | تهی نیست استنباط در کلید اولیه                                                                    | بله{.text-success}      |                                                                                                                                                                                            |
| E141-10    | نام در یک کلید خارجی را می توان در هر سفارش مشخص شده است                                          | نه{.text-danger}        |                                                                                                                                                                                            |
| **E151**   | **پشتیبانی تراکنش**                                                                               | **نه**{.text-danger}    |                                                                                                                                                                                            |
| E151-01    | بیانیه متعهد                                                                                      | نه{.text-danger}        |                                                                                                                                                                                            |
| E151-02    | بیانیه عقبگرد                                                                                     | نه{.text-danger}        |                                                                                                                                                                                            |
| **E152**   | **بیانیه معامله عمومی مجموعه**                                                                    | **نه**{.text-danger}    |                                                                                                                                                                                            |
| E152-01    | مجموعه بیانیه معامله: جداسازی سطح SERIALIZABLE بند                                                | نه{.text-danger}        |                                                                                                                                                                                            |
| E152-02    | تنظیم بیانیه معامله: فقط خواندن و خواندن نوشتن جملات                                              | نه{.text-danger}        |                                                                                                                                                                                            |
| **E153**   | **نمایش داده شد بهروز با زیرمجموعه**                                                              | **نه**{.text-danger}    |                                                                                                                                                                                            |
| **E161**   | **گذاشتن نظرات با استفاده از منجر منهای دو**                                                      | **بله**{.text-success}  |                                                                                                                                                                                            |
| **E171**   | **SQLSTATE پشتیبانی**                                                                             | **نه**{.text-danger}    |                                                                                                                                                                                            |
| **E182**   | **اتصال زبان میزبان**                                                                             | **نه**{.text-danger}    |                                                                                                                                                                                            |
| **F031**   | **دستکاری طرح اولیه**                                                                             | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| F031-01    | ایجاد بیانیه جدول برای ایجاد جداول پایه مداوم                                                     | نسبی{.text-warning}     | نه `SYSTEM VERSIONING`, `ON COMMIT`, `GLOBAL`, `LOCAL`, `PRESERVE`, `DELETE`, `REF IS`, `WITH OPTIONS`, `UNDER`, `LIKE`, `PERIOD FOR` بند و هیچ پشتیبانی برای کاربر حل و فصل انواع داده ها |
| F031-02    | ایجاد نمایش بیانیه                                                                                | نسبی{.text-warning}     | نه `RECURSIVE`, `CHECK`, `UNDER`, `WITH OPTIONS` بند و هیچ پشتیبانی برای کاربر حل و فصل انواع داده ها                                                                                      |
| F031-03    | بیانیه گرانت                                                                                      | بله{.text-success}      |                                                                                                                                                                                            |
| F031-04    | تغییر بیانیه جدول: اضافه کردن بند ستون                                                            | نسبی{.text-warning}     | هیچ پشتیبانی برای `GENERATED` بند و مدت زمان سیستم                                                                                                                                         |
| F031-13    | بیانیه جدول قطره: محدود کردن بند                                                                  | نه{.text-danger}        |                                                                                                                                                                                            |
| F031-16    | قطره مشاهده بیانیه: محدود بند                                                                     | نه{.text-danger}        |                                                                                                                                                                                            |
| F031-19    | لغو بیانیه: محدود کردن بند                                                                        | نه{.text-danger}        |                                                                                                                                                                                            |
| **F041**   | **جدول پیوست عمومی**                                                                              | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| F041-01    | عضویت داخلی (اما نه لزوما کلمه کلیدی درونی)                                                       | بله{.text-success}      |                                                                                                                                                                                            |
| F041-02    | کلیدواژه داخلی                                                                                    | بله{.text-success}      |                                                                                                                                                                                            |
| F041-03    | LEFT OUTER JOIN                                                                                   | بله{.text-success}      |                                                                                                                                                                                            |
| F041-04    | RIGHT OUTER JOIN                                                                                  | بله{.text-success}      |                                                                                                                                                                                            |
| F041-05    | بیرونی می پیوندد می توان تو در تو                                                                 | بله{.text-success}      |                                                                                                                                                                                            |
| F041-07    | جدول درونی در بیرونی چپ یا راست عضویت نیز می تواند مورد استفاده قرار گیرد در عضویت درونی          | بله{.text-success}      |                                                                                                                                                                                            |
| F041-08    | همه اپراتورهای مقایسه پشتیبانی می شوند (و نه فقط =)                                               | نه{.text-danger}        |                                                                                                                                                                                            |
| **F051**   | **تاریخ پایه و زمان**                                                                             | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| F051-01    | تاریخ نوع داده (از جمله پشتیبانی از تاریخ تحت اللفظی)                                             | نسبی{.text-warning}     | بدون تحت اللفظی                                                                                                                                                                            |
| F051-02    | نوع داده زمان (از جمله پشتیبانی از زمان تحت اللفظی) با دقت ثانیه کسری حداقل 0                     | نه{.text-danger}        |                                                                                                                                                                                            |
| F051-03    | نوع داده برچسب زمان (از جمله پشتیبانی از تحت اللفظی برچسب زمان) با دقت ثانیه کسری از حداقل 0 و 6  | نه{.text-danger}        | `DateTime64` زمان فراهم می کند قابلیت های مشابه                                                                                                                                            |
| F051-04    | مقایسه گزاره در تاریخ, زمان, و انواع داده های برچسب زمان                                          | نسبی{.text-warning}     | فقط یک نوع داده موجود است                                                                                                                                                                  |
| F051-05    | بازیگران صریح و روشن بین انواع تاریخ ساعت و انواع رشته شخصیت                                      | بله{.text-success}      |                                                                                                                                                                                            |
| F051-06    | CURRENT\_DATE                                                                                     | نه{.text-danger}        | `today()` مشابه است                                                                                                                                                                        |
| F051-07    | LOCALTIME                                                                                         | نه{.text-danger}        | `now()` مشابه است                                                                                                                                                                          |
| F051-08    | LOCALTIMESTAMP                                                                                    | نه{.text-danger}        |                                                                                                                                                                                            |
| **F081**   | **اتحادیه و به جز در دیدگاه**                                                                     | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| **F131**   | **عملیات گروه بندی شده**                                                                          | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| F131-01    | جایی که, گروه های, و داشتن بند در نمایش داده شد با نمایش گروه بندی پشتیبانی                       | بله{.text-success}      |                                                                                                                                                                                            |
| F131-02    | جداول چندگانه در نمایش داده شد با نمایش گروه بندی پشتیبانی می شود                                 | بله{.text-success}      |                                                                                                                                                                                            |
| F131-03    | تنظیم توابع پشتیبانی شده در نمایش داده شد با نمایش گروه بندی می شوند                              | بله{.text-success}      |                                                                                                                                                                                            |
| F131-04    | Subqueries با گروه و داشتن بند و گروه بندی views                                                  | بله{.text-success}      |                                                                                                                                                                                            |
| F131-05    | تک ردیف با گروه و داشتن بند و دیدگاه های گروه بندی شده را انتخاب کنید                             | نه{.text-danger}        |                                                                                                                                                                                            |
| **F181**   | **پشتیبانی از ماژول های متعدد**                                                                   | **نه**{.text-danger}    |                                                                                                                                                                                            |
| **F201**   | **تابع بازیگران**                                                                                 | **بله**{.text-success}  |                                                                                                                                                                                            |
| **F221**   | **پیش فرض های صریح**                                                                              | **نه**{.text-danger}    |                                                                                                                                                                                            |
| **F261**   | **عبارت مورد**                                                                                    | **بله**{.text-success}  |                                                                                                                                                                                            |
| F261-01    | مورد ساده                                                                                         | بله{.text-success}      |                                                                                                                                                                                            |
| F261-02    | مورد جستجو                                                                                        | بله{.text-success}      |                                                                                                                                                                                            |
| F261-03    | NULLIF                                                                                            | بله{.text-success}      |                                                                                                                                                                                            |
| F261-04    | COALESCE                                                                                          | بله{.text-success}      |                                                                                                                                                                                            |
| **F311**   | **بیانیه تعریف طرح**                                                                              | **نسبی**{.text-warning} |                                                                                                                                                                                            |
| F311-01    | CREATE SCHEMA                                                                                     | نه{.text-danger}        |                                                                                                                                                                                            |
| F311-02    | ایجاد جدول برای جداول پایه مداوم                                                                  | بله{.text-success}      |                                                                                                                                                                                            |
| F311-03    | CREATE VIEW                                                                                       | بله{.text-success}      |                                                                                                                                                                                            |
| F311-04    | CREATE VIEW: WITH CHECK OPTION                                                                    | نه{.text-danger}        |                                                                                                                                                                                            |
| F311-05    | بیانیه گرانت                                                                                      | بله{.text-success}      |                                                                                                                                                                                            |
| **F471**   | **مقادیر زیر مقیاس**                                                                              | **بله**{.text-success}  |                                                                                                                                                                                            |
| **F481**   | **پیش فرض صفر گسترش یافته است**                                                                   | **بله**{.text-success}  |                                                                                                                                                                                            |
| **F812**   | **عمومی ضعیف**                                                                                    | **نه**{.text-danger}    |                                                                                                                                                                                            |
| **T321**   | **روال عمومی گذاشتن استناد**                                                                      | **نه**{.text-danger}    |                                                                                                                                                                                            |
| T321-01    | توابع تعریف شده توسط کاربر بدون اضافه بار                                                         | نه{.text-danger}        |                                                                                                                                                                                            |
| T321-02    | روش های ذخیره شده تعریف شده توسط کاربر بدون اضافه بار                                             | نه{.text-danger}        |                                                                                                                                                                                            |
| T321-03    | فراخوانی تابع                                                                                     | نه{.text-danger}        |                                                                                                                                                                                            |
| T321-04    | بیانیه تماس                                                                                       | نه{.text-danger}        |                                                                                                                                                                                            |
| T321-05    | بیانیه بازگشت                                                                                     | نه{.text-danger}        |                                                                                                                                                                                            |
| **T631**   | **در گزاره با یک عنصر لیست**                                                                      | **بله**{.text-success}  |                                                                                                                                                                                            |
