---
machine_translated: true
machine_translated_rev: 72537a2d527c63c07aa5d2361a8829f3895cf2bd
toc_priority: 44
toc_title: "\u0631\u06CC\u0627\u0636\u06CC"
---

# توابع ریاضی {#mathematical-functions}

همه توابع بازگشت یک عدد شناور64. دقت و صحت نتیجه به حداکثر دقت ممکن است اما نتیجه ممکن است همزمان با ماشین representable شماره نزدیکترین مربوطه عدد حقیقی است.

## ا() {#e}

بازگرداندن یک عدد شناور64 است که نزدیک به تعداد الکترونیکی.

## پی() {#pi}

Returns a Float64 number that is close to the number π.

## واردات) {#expx}

می پذیرد یک استدلال عددی و یک عدد شناور64 نزدیک به توان استدلال را برمی گرداند.

## هشدار داده می شود) {#logx-lnx}

یک استدلال عددی را می پذیرد و یک عدد شناور64 را نزدیک به لگاریتم طبیعی استدلال می کند.

## exp2(x) {#exp2x}

می پذیرد یک استدلال عددی و یک عدد شناور می گرداند نزدیک به 2 به قدرت ایکس.

## log2(x) {#log2x}

می پذیرد یک استدلال عددی و یک عدد جسم شناور64 را برمی گرداند نزدیک به لگاریتم باینری از استدلال.

## exp10(x) {#exp10x}

می پذیرد یک استدلال عددی و یک عدد شناور می گرداند نزدیک به 10 به قدرت ایکس.

## ثبت 10 (ایکس) {#log10x}

می پذیرد یک استدلال عددی و یک عدد جسم شناور64 نزدیک به لگاریتم اعشاری از استدلال را برمی گرداند.

## هشدار داده می شود) {#sqrtx}

می پذیرد یک استدلال عددی و یک عدد شناور می گرداند نزدیک به ریشه مربع از استدلال.

## هشدار داده می شود) {#cbrtx}

می پذیرد یک استدلال عددی و یک عدد جسم شناور را برمی گرداند نزدیک به ریشه مکعب استدلال.

## عارف) {#erfx}

اگر ‘x’ سپس غیر منفی است `erf(x / σ√2)` احتمال این که یک متغیر تصادفی داشتن یک توزیع نرمال با انحراف استاندارد است ‘σ’ طول می کشد ارزش است که از مقدار مورد انتظار توسط بیش از هم جدا ‘x’.

مثال (قانون سه سیگما):

``` sql
SELECT erf(3 / sqrt(2))
```

``` text
┌─erf(divide(3, sqrt(2)))─┐
│      0.9973002039367398 │
└─────────────────────────┘
```

## erfc(x) {#erfcx}

قبول یک استدلال عددی و یک عدد شناور را برمی گرداند نزدیک به 1 - دوره (ایکس), اما بدون از دست دادن دقت برای بزرگ ‘x’ ارزشهای خبری عبارتند از:

## هشدار داده می شود) {#lgammax}

لگاریتم تابع گاما.

## ترجما) {#tgammax}

تابع گاما

## گناه) {#sinx}

سینوس.

## کسینوس (ایکس) {#cosx}

کسینوس.

## قهوهای مایل به زرد(ایکس) {#tanx}

خط مماس.

## اطلاعات دقیق) {#asinx}

سینوسی قوس.

## acos(x) {#acosx}

قوس کسینوس.

## هشدار داده می شود) {#atanx}

مماس قوس.

## صدای انفجار (ایکس, و), قدرت (ایکس, و) {#powx-y-powerx-y}

طول می کشد دو استدلال عددی ایکس و و و. گرداند یک عدد جسم شناور64 نزدیک به ایکس به قدرت و.

## اینتکسپ2 {#intexp2}

می پذیرد یک استدلال عددی و باز می گردد یک عدد اوینت64 نزدیک به 2 به قدرت ایکس.

## اینتکسپ10 {#intexp10}

می پذیرد یک استدلال عددی و باز می گردد یک عدد اوینت64 نزدیک به 10 به قدرت ایکس.

[مقاله اصلی](https://clickhouse.tech/docs/en/query_language/functions/math_functions/) <!--hide-->
