---
machine_translated: true
machine_translated_rev: 72537a2d527c63c07aa5d2361a8829f3895cf2bd
toc_priority: 51
toc_title: "\u062A\u0648\u0644\u06CC\u062F \u0627\u0639\u062F\u0627\u062F \u0634\u0628\
  \u0647 \u062A\u0635\u0627\u062F\u0641\u06CC"
---

# توابع برای تولید اعداد شبه تصادفی {#functions-for-generating-pseudo-random-numbers}

ژنراتور غیر رمزنگاری اعداد شبه تصادفی استفاده می شود.

تمام توابع قبول استدلال صفر و یا یک استدلال.
اگر استدلال به تصویب می رسد, این می تواند هر نوع, و ارزش خود را برای هر چیزی استفاده نمی شود.
تنها هدف از این استدلال این است که برای جلوگیری از حذف خشونت مشترک, به طوری که دو نمونه مختلف از همان تابع بازگشت ستون های مختلف با شماره های مختلف تصادفی.

## رند {#rand}

بازده یک شبه تصادفی UInt32 شماره به طور مساوی توزیع شده در میان تمام UInt32 از نوع اعداد است.
با استفاده از یک ژنراتور همخوان خطی.

## رند64 {#rand64}

بازده یک شبه تصادفی UInt64 شماره به طور مساوی توزیع شده در میان تمام UInt64 از نوع اعداد است.
با استفاده از یک ژنراتور همخوان خطی.

## شرکت رندکونستانت {#randconstant}

تولید یک ستون ثابت با یک مقدار تصادفی.

**نحو**

``` sql
randConstant([x])
```

**پارامترها**

-   `x` — [عبارت](../syntax.md#syntax-expressions) در نتیجه در هر یک از [انواع داده های پشتیبانی شده](../data-types/index.md#data_types). ارزش حاصل دور انداخته می شود, اما بیان خود را اگر برای دور زدن استفاده [رفع ضعف مشترک](index.md#common-subexpression-elimination) اگر تابع چندین بار در یک پرس و جو نامیده می شود. پارامتر اختیاری.

**مقدار بازگشتی**

-   عدد شبه تصادفی.

نوع: [UInt32](../data-types/int-uint.md).

**مثال**

پرسوجو:

``` sql
SELECT rand(), rand(1), rand(number), randConstant(), randConstant(1), randConstant(number)
FROM numbers(3)
```

نتیجه:

``` text
┌─────rand()─┬────rand(1)─┬─rand(number)─┬─randConstant()─┬─randConstant(1)─┬─randConstant(number)─┐
│ 3047369878 │ 4132449925 │   4044508545 │     2740811946 │      4229401477 │           1924032898 │
│ 2938880146 │ 1267722397 │   4154983056 │     2740811946 │      4229401477 │           1924032898 │
│  956619638 │ 4238287282 │   1104342490 │     2740811946 │      4229401477 │           1924032898 │
└────────────┴────────────┴──────────────┴────────────────┴─────────────────┴──────────────────────┘
```

[مقاله اصلی](https://clickhouse.tech/docs/en/query_language/functions/random_functions/) <!--hide-->
